#ifndef __ANIME_H__
#define __ANIME_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define ANIME_MAX_PAT_CNT			15
#define ANIME_MAX_DAT_CNT			21
#define ANIME_MAX_STR_SIZE			10

enum {
	ANIME_ACT_EXEC = 0x01,					// s
	ANIME_ACT_END,							// I
};

//---------------------------------------------------------------------------

typedef struct {
	u32   act;
	u32   no;
	u32   var;
	u32   wait;
	char* pCur;
} ST_ANIME;


typedef struct {
	char* pStr;								// ߂̕
	void  (*pFunc)(void);					// ߂̊֐
} ST_ANIME_TABLE;

//---------------------------------------------------------------------------
EWRAM_CODE void AnimeInit(void);
EWRAM_CODE void AnimeSetDat(u32 no);

EWRAM_CODE void AnimeExec(void);
EWRAM_CODE void AnimeExecSub(void);
EWRAM_CODE void AnimeExecBg(void);
EWRAM_CODE void AnimeExecCrop(void);
EWRAM_CODE void AnimeExecCrop2(void);
EWRAM_CODE void AnimeExecCrop3(void);
EWRAM_CODE void AnimeExecBlend(void);
EWRAM_CODE void AnimeExecBlend2(void);
EWRAM_CODE void AnimeExecEffect(void);
EWRAM_CODE void AnimeExecWait(void);
EWRAM_CODE void AnimeExecBgm(void);
EWRAM_CODE void AnimeExecEnd(void);
EWRAM_CODE void AnimeExecVar(void);
EWRAM_CODE void AnimeExecPos(void);
EWRAM_CODE void AnimeExecInc(void);
EWRAM_CODE void AnimeExecDec(void);
EWRAM_CODE void AnimeExecJae(void);
EWRAM_CODE void AnimeExecJbe(void);
EWRAM_CODE void AnimeExecEnd(void);

EWRAM_CODE bool AnimeIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
