#include "file.h"
#include "libmy/gbfs.h"


//---------------------------------------------------------------------------
const char* const FileSceneTable[FILE_MAX_SCENE_CNT] = {
	"FGAY01",
	"FGAY02A",
	"FGAY02B",
	"FGAY03",
	"FGAY04",
	"FGAY05A",
	"FGAY05B",
	"FGAY05C",
	"FGAY06",
	"FGAY07A",
	"FGAY07B",
	"FGAY08A",
	"FGAY08B",
	"FGAY08C",
	"FGAY09A",
	"FGAY09B",
	"FGAY10A",
	"FGAY10B",
	"FGAY11",
	"FGAY12",
	"FGAY13",
	"FGAY14",
	"FGAY15",
	"FGAY16A",
	"FGAY16B",
	"FGAY16C",
	"FGAY17",
	"FGAY18",
	"FGAY19",
	"FGAY20A",
	"FGAY20B",
	"FGMI01",
	"FGMI02",
	"FGMI03",
	"FGMI04A",
	"FGMI04B",
	"FGMI04C",
	"FGMI05",
	"FGMI06",
	"FGMI07A",
	"FGMI07B",
	"FGMI07C",
	"FGMI07D",
	"FGMI07E",
	"FGMI08",
	"FGMI09A",
	"FGMI09B",
	"FGMI10A",
	"FGMI10B",
	"FGMI10C",
	"FGMI11",
	"FGMI12",
	"FGMI13",
	"FGMI14",
	"FGMI15",
	"FGMI16",
	"FGMI17A",
	"FGMI17B",
	"FGMI18",
	"FGMK01",
	"FGMK02A",
	"FGMK03A",
	"FGMK03B",
	"FGMK05",
	"FGMK06",
	"FGMK07",
	"FGMK08",
	"FGMK10",
	"FGMK11A",
	"FGMK11B",
	"FGMK11C",
	"FGMK12",
	"FGMK13",
	"FGMK14",
	"FGMK15A",
	"FGMK15B",
	"FGMK16A",
	"FGMK16B",
	"FGNY01",
	"FGNY02A",
	"FGNY02B",
	"FGNY031A",
	"FGNY031B",
	"FGNY031C",
	"FGNY032A",
	"FGNY032B",
	"FGNY04A",
	"FGNY04B",
	"FGNY04C",
	"FGNY04D",
	"FGNY04E",
	"FGNY05",
	"FGNY06A",
	"FGNY06B",
	"FGNY06C",
	"FGNY07A",
	"FGNY07B",
	"FGNY08A",
	"FGNY08B",
	"FGNY08C",
	"FGNY09",
	"FGNY10A",
	"FGNY11",
	"FGNY12",
	"FGNY13",
	"FGNY14",
	"FGNY15",
	"FGSR01A",
	"FGSR01B",
	"FGSR02A",
	"FGSR02B",
	"FGSR031B",
	"FGSR032A",
	"FGSR032B",
	"FGSR032C",
	"FGSR04",
	"FGSR05A",
	"FGSR05B",
	"FGSR06",
	"FGSR07A",
	"FGSR07B",
	"FGSR08A",
	"FGSR08B",
	"FGSR09",
	"FGSR10A",
	"FGSR10B",
	"FGSR10C",
	"FGSR11A",
	"FGSR11B",
	"FGSR12",
	"FGSR13",
	"FGSR14",
	"FGSR15",
	"FGSR16",
};


//---------------------------------------------------------------------------
EWRAM_CODE void FileInit(void)
{
	// EMPTY
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetDat(u32 no)
{
	char buf[32];
	_Sprintf(buf, "SEEN%03d.dat", no);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetImg(char* pStr)
{
	char buf[32];
	_Sprintf(buf, "%s.img", pStr);

	FileCalcToupper(buf);
	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetImgMask(char* pStr)
{
	char buf[32];
	_Sprintf(buf, "%s_M.img", pStr);

	FileCalcToupper(buf);
	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetSnd(u32 num)
{
	char buf[32];
	_Sprintf(buf, "tr_%03d.8ad", num);

	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u8* FileGetSe(char* pStr)
{
	char buf[32];
	_Sprintf(buf, "%s.raw", pStr);

	FileCalcToupper(buf);
	return GbfsGetSafePointer(buf);
}
//---------------------------------------------------------------------------
EWRAM_CODE u32 FileGetSize(void)
{
	return GbfsGetFileSize();
}
//---------------------------------------------------------------------------
EWRAM_CODE char* FileGetScene(u32 num)
{
	_ASSERT(num < FILE_MAX_SCENE_CNT);

	return (char*)FileSceneTable[num];
}
//---------------------------------------------------------------------------
EWRAM_CODE void FileCalcToupper(char* pStr)
{
	u32 i = 0;

	while(pStr[i] != '.')
	{
		pStr[i] = _Toupper(pStr[i]);
		i++;
	}
}
