#ifndef __IMG_H__
#define __IMG_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define IMG_MAX_STR_SIZE		16

// TODO 

enum {
	// XNvgp
	IMG_EFFECT_0      = 0,		// 킶
	IMG_EFFECT_26     = 26,		// uh
	IMG_EFFECT_48     = 48,		// E
	IMG_EFFECT_60     = 60,		// 킶
	IMG_EFFECT_105    = 105,	// uh
	IMG_EFFECT_200    = 200,	// ʏRs[

	// Aj[Vpiڃobt@`j
	IMG_EFFECT_NORMAL = 300,	// ʏRs[
	IMG_EFFECT_MASK   = 301,	// 킶
	IMG_EFFECT_BLEND  = 302,	// uh
	IMG_EFFECT_LR     = 303,	// E
	IMG_EFFECT_RL     = 304,	// E
	IMG_EFFECT_UD     = 305,	// と
	IMG_EFFECT_STR    = 306,	// XN[
	IMG_EFFECT_OP1    = 307,	// OPXN[1i؁j
	IMG_EFFECT_OP2    = 308,	// OPXN[2ij
	IMG_EFFECT_END,
};

//---------------------------------------------------------------------------

typedef struct {
	bool isDraw;
	u32  effect;
	u32  step;

	char bgStr[IMG_MAX_STR_SIZE];
	char bg2Str[IMG_MAX_STR_SIZE];
	char chrStr[IMG_MAX_STR_SIZE];

	bool isDrawCalendar;
	u32  day;
} ST_IMG;

typedef struct {
	u16 cx;
	u16 cy;
} __PACKED ST_IMG_HEADER;

//---------------------------------------------------------------------------
EWRAM_CODE void ImgInit(void);

IWRAM_CODE void ImgExec(void);
IWRAM_CODE void ImgExecBuf(void);
IWRAM_CODE void ImgExecEffect0(void);
IWRAM_CODE void ImgExecEffect48(void);
IWRAM_CODE void ImgExecEffect200(void);
IWRAM_CODE void ImgExecEffectNormal(void);
IWRAM_CODE void ImgExecEffectMask(void);
IWRAM_CODE void ImgExecEffectLr(void);
IWRAM_CODE void ImgExecEffectRl(void);
IWRAM_CODE void ImgExecEffectUd(void);
IWRAM_CODE void ImgExecEffectStr(void);
IWRAM_CODE void ImgExecEffectOp1(void);
IWRAM_CODE void ImgExecEffectOp2(void);

EWRAM_CODE void ImgDrawBg(char* pStr);
EWRAM_CODE void ImgDrawCrop(u32 sx, u32 sy, char* pStr);
EWRAM_CODE void ImgDrawCropCenter(char* pStr);
EWRAM_CODE void ImgDrawBlend(u32 sx, u32 sy, char* pStr);
EWRAM_CODE void ImgDrawBlendChr(char* pStr);
EWRAM_CODE void ImgDrawCalendar(void);

EWRAM_CODE void ImgSetBg(char* pStr);
EWRAM_CODE void ImgSetBg2(char* pStr);
EWRAM_CODE void ImgSetChr(char* pStr);
EWRAM_CODE void ImgSetCalendar(u32 day);
EWRAM_CODE void ImgSetEffect(u32 no);
EWRAM_CODE void ImgClear(void);
EWRAM_CODE void ImgDirect(char* pStr);

EWRAM_CODE bool ImgIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
