#ifndef __LEX_H__
#define __LEX_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"


//---------------------------------------------------------------------------
#define LEX_MAX_CNT					2
#define LEX_MAX_STR_CNT				256

enum {
	LEX_TOKEN_NUM,
	LEX_TOKEN_STR,
	LEX_TOKEN_CUM,
	LEX_TOKEN_SPACE,
	LEX_TOKEN_COMMENT,
	LEX_TOKEN_DQUOTE,
	LEX_TOKEN_CR,
	LEX_TOKEN_LF,
	LEX_TOKEN_END,
};

enum {
	LEX_ID_ANIME,
	LEX_ID_NV,
};

//---------------------------------------------------------------------------
typedef struct {
	char* pCur;								// J[\
	char* pOld;								// UnGetpJ[\
	u32   type;								// g[N^Cv
	s32   num;								//  or ̒
	char  str[LEX_MAX_STR_CNT] ALIGN(4);	// 
} ST_LEX;


//---------------------------------------------------------------------------
EWRAM_CODE void  LexInit(void);
EWRAM_CODE void  LexSetCur(u32 id, char* pCur);
EWRAM_CODE char* LexGetCur(u32 id);

EWRAM_CODE s32   LexGetNum(u32 id);
EWRAM_CODE char* LexGetStr(u32 id);
EWRAM_CODE char  LexGetChr(u32 id);

IWRAM_CODE void  LexGetToken(u32 id, bool isChr);
IWRAM_CODE u32   LexGetType(char chr);
IWRAM_CODE void  LexSkipLine(u32 id);
IWRAM_CODE void  LexSkipLf(u32 id);
EWRAM_CODE void  LexUnGet(u32 id);

EWRAM_CODE bool  LexIsEnd(u32 id);

#ifdef __cplusplus
}
#endif
#endif
