#ifndef __MODE3_H__
#define __MODE3_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------
#define MODE3_MAX_BUF_SIZE			(SCREEN_WIDTH * SCREEN_HEIGHT * 2)


//---------------------------------------------------------------------------

typedef struct {
	bool isDraw;

	u16  bg[MODE3_MAX_BUF_SIZE/2] ALIGN(4);
	u16  chr[MODE3_MAX_BUF_SIZE/2] ALIGN(4);
	u8   mask[MODE3_MAX_BUF_SIZE/2] ALIGN(4);

} ST_MODE3;


//---------------------------------------------------------------------------
EWRAM_CODE void Mode3Init(void);
IWRAM_CODE void Mode3Exec(void);

IWRAM_CODE void Mode3DrawBg(u16* pImg);
IWRAM_CODE void Mode3DrawChr(u16* pImg);
IWRAM_CODE void Mode3DrawCrop(u32 sx, u32 sy, u32 cx, u32 cy, u16* pImg);
IWRAM_CODE void Mode3DrawBlend(u32 sx, u32 sy, u32 cx, u32 cy, u16* pImg, u16* pMask);
IWRAM_CODE void Mode3DrawBlendWhite(u32 sx, u32 sy, u32 cx, u32 cy, u32 ex, u32 ey, u32 alpha);
IWRAM_CODE void Mode3Copy(u32 sx, u32 sy, u32 cx, u32 cy);
IWRAM_CODE void Mode3Copy2(u32 sx, u32 sy, u32 cx, u32 cy, u32 ex, u32 ey);
IWRAM_CODE void Mode3ScrollOp(u32 cnt);
IWRAM_CODE void Mode3ScrollOpSub(u16* pSrc, u16* pDst, u32 size);

EWRAM_CODE void Mode3SetDraw(bool isDraw);


#ifdef __cplusplus
}
#endif
#endif
