#include "manage.h"
#include "img.h"
#include "text.h"
#include "history.h"
#include "menu.h"
#include "nv.h"
#include "bgm.h"
#include "file.h"
#include "siori.h"
#include "se.h"
#include "anime.h"


//---------------------------------------------------------------------------
ST_MANAGE Manage;


//---------------------------------------------------------------------------
EWRAM_CODE void ManageInit(void)
{
	_Memset(&Manage, 0x00, sizeof(ST_MANAGE));

	ManageSetAct(MANAGE_ACT_INIT);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageSetAct(u32 act)
{
	Manage.act = act;
	Manage.actStep = 0;
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExec(void)
{
	switch(Manage.act)
	{
	case MANAGE_ACT_INIT:
		ManageExecInit();
		break;

	case MANAGE_ACT_TITLE:
		ManageExecTitle();
		break;

	case MANAGE_ACT_NV:
		ManageExecNv();
		break;

	default:
		SystemError("[Err] ManageExec Manage.act=%d\n", Manage.act);
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecInit(void)
{
	FileInit();
	BgmInit();
	SeInit();

	TextInit();
	ImgInit();

	HistoryInit();
	AnimeInit();
	MenuInit();
	NvInit();

	SioriInit();

	ManageSetAct(MANAGE_ACT_TITLE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecTitle(void)
{
	switch(Manage.actStep)
	{
	case 0:
		AnimeSetDat(14);
		Manage.actStep++;
		break;

	case 1:
		AnimeExec();
		ImgExec();

		if(AnimeIsEnd() == TRUE)
		{
			MenuSetTitle();
			Manage.actStep++;
		}
		break;

	case 2:
		MenuExec();

		if(MenuIsEnd() == TRUE)
		{
			ManageSetAct(MANAGE_ACT_NV);
		}
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void ManageExecNv(void)
{
	ImgExec();
	TextExec();

	HistoryExec();
	AnimeExec();
	MenuExec();

	NvExec();

	if(NvIsEnd() == TRUE && ImgIsEnd() == TRUE)
	{
		ManageSetAct(MANAGE_ACT_TITLE);
	}
}
