#ifndef __NV_H__
#define __NV_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define NV_MAX_VAR_NUM_CNT				256
#define NV_MAX_VAR_STR_CNT				2
#define NV_MAX_MSG_SIZE					256
#define NV_MAX_STR_SIZE					16

#define NV_MAX_SEL_CNT					3
#define NV_MAX_SEL_STR_SIZE				(44+2)
#define NV_MAX_CALL_CNT					10


enum {
	NV_ACT_PARSE = 0x01,
	NV_ACT_KEY,
	NV_ACT_KEY_WAIT,
	NV_ACT_SELECT,
	NV_ACT_END_READY,
	NV_ACT_END,
};

//---------------------------------------------------------------------------

typedef struct {
	u32   act;
	u32   actStep;
	s32   wait;
	bool  isLoop;
	bool  isSkip;					// bZ[WGtFNgXLbv

	// XNvgt@C
	u32   no;						// t@C̔ԍ
	char* pHead;					// t@C̐擪
	char* pCur;						// J[\

	// bZ[W
	u8    msg[NV_MAX_MSG_SIZE] ALIGN(4);
	u32   msgCnt;

	// ϐ
	s8    varNum[NV_MAX_VAR_NUM_CNT];
	char  varStr[NV_MAX_VAR_STR_CNT][NV_MAX_STR_SIZE];

	// I
	s32   sel;						// [UIĂ鍀
	s32   selCnt;					// o^
	u32   selVar;					// ʂԂtOԍivarCountƑΉj
	u8    selStr[NV_MAX_SEL_CNT][NV_MAX_SEL_STR_SIZE] ALIGN(4);

	// XNvgR[
	s32   callCnt;
	u32   callNo[NV_MAX_CALL_CNT];
	u32   callAdr[NV_MAX_CALL_CNT];
} ST_NV;


//---------------------------------------------------------------------------
EWRAM_CODE void  NvInit(void);

EWRAM_CODE void  NvExec(void);
EWRAM_CODE void  NvExecKey(void);
EWRAM_CODE bool  NvExecKeySub(void);
EWRAM_CODE void  NvExecKeyWait(void);
EWRAM_CODE void  NvExecSelect(void);
EWRAM_CODE void  NvExecEndReady(void);

EWRAM_CODE void  NvSetAct(u32 act);
EWRAM_CODE void  NvSetDat(u32 no);
EWRAM_CODE void  NvSetSkip(bool is);
EWRAM_CODE void  NvSetVarNum(u32 idx, u32 val);
EWRAM_CODE u32   NvGetVarNum(u32 idx);
EWRAM_CODE u32   NvGetVarNumMap(u32 idx);
EWRAM_CODE void  NvSetVarStr(u32 idx, char* pStr);
EWRAM_CODE char* NvGetVarStr(u32 idx);

EWRAM_CODE bool  NvIsEnd(void);


#ifdef __cplusplus
}
#endif
#endif
