#ifndef __NV2_H__
#define __NV2_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define NV_MAX_PAT_TABLE_CNT			27


//---------------------------------------------------------------------------

typedef struct {
	char* pStr;						// ߂̕
	void  (*pFunc)(void);			// ߂̊֐
} ST_NV_PAT_TABLE;


//---------------------------------------------------------------------------
IWRAM_CODE void  NvExecParse(void);
IWRAM_CODE void  NvExecParseSub(void);
IWRAM_CODE void  NvExecParseSubPatch();

EWRAM_CODE void  NvExecParseKey(void);
EWRAM_CODE void  NvExecParseKey2(void);
EWRAM_CODE void  NvExecParseShow(void);
EWRAM_CODE void  NvExecParseImg1(void);
EWRAM_CODE void  NvExecParseImg2(void);
EWRAM_CODE void  NvExecParseImg3(void);
EWRAM_CODE void  NvExecParseImg4(void);
EWRAM_CODE void  NvExecParseImg5(void);
EWRAM_CODE void  NvExecParseJump1(void);
EWRAM_CODE void  NvExecParseJump2(void);
EWRAM_CODE void  NvExecParseJump3(void);
EWRAM_CODE void  NvExecParseCalendar(void);
EWRAM_CODE void  NvExecParseCall2(void);
EWRAM_CODE void  NvExecParseRet(void);
EWRAM_CODE void  NvExecParseVar(void);
EWRAM_CODE void  NvExecParseStr(void);
EWRAM_CODE void  NvExecParseBgm(void);
EWRAM_CODE void  NvExecParseBgmFade(void);
EWRAM_CODE void  NvExecParseWav(void);
EWRAM_CODE void  NvExecParseWavStop(void);
EWRAM_CODE void  NvExecParseWait(void);
EWRAM_CODE void  NvExecParseSelect(void);
EWRAM_CODE void  NvExecParseFade(void);
EWRAM_CODE void  NvExecParseMsgHide(void);
EWRAM_CODE void  NvExecParseShake(void);
EWRAM_CODE void  NvExecParseFlash(void);
EWRAM_CODE void  NvExecParseTitle(void);

IWRAM_CODE void  NvMsg(char* p);
IWRAM_CODE void  NvText(void);
IWRAM_CODE bool  NvGetIfCondition(void);
EWRAM_CODE char* NvGetStr(void);
EWRAM_CODE u32   NvGetNum(void);
EWRAM_CODE u32   NvGetNum2(void);
EWRAM_CODE u32   NvGetVar(void);

EWRAM_CODE void  NvSelPush(void);
EWRAM_CODE void  NvCallPush(void);
EWRAM_CODE void  NvCallPop(void);
EWRAM_CODE void  NvEffect(u32 idx);
EWRAM_CODE void  NvSkip(void);

EWRAM_CODE bool  NvIsStr(char* pSrc, char* pDst);
EWRAM_CODE bool  NvIsStrNext(char* pStr);

#ifdef __cplusplus
}
#endif
#endif
