#include <stdio.h>
#include <string.h>
#include "gba.h"


//---------------------------------------------------------------------------
u32  OpenBuf(char* pName, u8** pBuf);


//---------------------------------------------------------------------------
int main(int argc,char **argv)
{
	if(argc != 4)
	{
		printf("err argc\n");
		exit(1);
	}

	u8* pSrc;
	u8* pDst;
	u8* pMask;
	u32 srcSize;
	u32 dstSize;
	u32 maskSize;

	srcSize  = OpenBuf(argv[1], &pSrc);
	dstSize  = OpenBuf(argv[2], &pDst);
	maskSize = OpenBuf(argv[3], &pMask);

	printf("pdtmask ... %s->%s(%s)\n", argv[1], argv[2], argv[3]);

	//
	int x, y;
	BYTE bmp_fileh[14];
	BYTE bmp_infoh[40];

	u8* pCur1 = pSrc  + sizeof(bmp_fileh) + sizeof(bmp_infoh);
	u8* pCur2 = pDst  + sizeof(bmp_fileh) + sizeof(bmp_infoh);
	u8* pCur3 = pMask + sizeof(bmp_fileh) + sizeof(bmp_infoh) + 256*4;

	for(y=0; y<480; y++)
	{
		for(x=0; x<640; x++)
		{
			if(*pCur3 == 0x00)
			{
				*(pCur2+0) = *(pCur1+0);
				*(pCur2+1) = *(pCur1+1);
				*(pCur2+2) = *(pCur1+2);
			}

			pCur1 += 3;
			pCur2 += 3;
			pCur3 += 1;
		}
	}


	//
	FILE* fp = fopen(argv[2], "wb");

	if(fp == NULL)
	{
		printf("err save\n");
		exit(1);
	}
	fwrite(pDst, dstSize, 1, fp);


	fclose(fp);
	free(pSrc);
	free(pDst);
	free(pMask);

	return 0;
}
//---------------------------------------------------------------------------
u32 OpenBuf(char* pName, u8** pBuf)
{
	FILE* fp = fopen(pName, "rb");

	if(fp == NULL)
	{
		printf("err filename\n");
		exit(1);
	}

	fpos_t fsize;
	fseek(fp,0,SEEK_END);
	fgetpos(fp, &fsize);
	fseek(fp,0,SEEK_SET);

	*pBuf = (u8*)calloc(fsize, sizeof(u8));
	fread(*pBuf, sizeof(u8), fsize, fp);

	fclose(fp);
	return fsize;
}
