#include <stdio.h>
#include <string.h>
#include <stdlib.h>


//---------------------------------------------------------------------------
typedef unsigned char  byte;
typedef unsigned short word;


//---------------------------------------------------------------------------
#pragma pack(1)

typedef struct {
	char sig[16];
	int  dnum;
	char unknown[12];
} FILEHEADER;

typedef struct {
	char name[16];
	int  offset;
	int  compsize;
	int  orgsize;
	int  unknown;
} DATAHEADER;

typedef struct {
	char sign[8];
	int  orgsize;
	int  compsize;
} DATAHEAD;

#pragma pack(0)

//---------------------------------------------------------------------------
int decode(byte* src, byte* dst);


//---------------------------------------------------------------------------
int main(int argc, char** argv)
{
	FILEHEADER fh;
	DATAHEADER dh;

	char  fname[FILENAME_MAX + 1];
	FILE* src;
	FILE* dst;
	byte* compdata;
	byte* orgdata;
	int   i;

	if(argc < 2)
	{
		strcpy(fname, "SEEN.TXT");
	}
	else
	{
		strcpy(fname, argv[1]);
	}

	src = fopen(fname, "rb");
	if(src == NULL)
	{
		printf("rddmt@CJ܂ł\n");
		exit(-1);
    }
	fread(&fh, 1, sizeof(fh), src);


	if(strcmp( fh.sig, "PACL" ) != 0)
	{
		printf("rddmt@Cł͂܂\n");
		exit(-1);
	}

	for(i=0; i<fh.dnum; i++)
	{
		fseek(src, sizeof(fh) + sizeof(dh) * i, SEEK_SET);
		fread(&dh, 1, sizeof(dh), src);
		printf("seencut ... %s\n", dh.name);

		compdata = (byte*)malloc(dh.compsize);
		orgdata  = (byte*)malloc(dh.orgsize);

		if(compdata == NULL || orgdata == NULL)
		{
			printf("mۂł܂ł\n");
			exit(-1);
		}

		fseek(src, dh.offset, SEEK_SET);
		fread(compdata, 1, dh.compsize, src);
		decode(compdata, orgdata);

		dst = fopen(dh.name, "wb");
		if(dst == NULL)
		{
			printf("݃t@CJ܂łi%sj\n", dh.name);
			continue;
		}
		fwrite(orgdata, 1, dh.orgsize, dst);


		free(compdata);
		free(orgdata);
		fclose(dst);
	}
	fclose( src );
	return 0;

}
//---------------------------------------------------------------------------
int decode(byte* src, byte* dst)
{
	DATAHEAD dh;
	byte* end;
	int f, d, l, cnt, i;
	word w;

	dh = *(DATAHEAD*)src;
	src += sizeof(DATAHEAD);

	cnt = 0;
	end = dst + dh.orgsize;

	while(dst < end)
	{
		if((cnt %= 8) == 0)
		{
			f = * src++;
		}

		if(f & (0x80 >> cnt))
		{
			*dst++ = *src++;
		}
		else
		{
			w = *src + (*(src+1) << 8);
			src += 2;
			
			l = (w &  0xF) + 2;
			d = (w >> 4);
			
			for(i=0; i<l; i++)
			{
				*dst = *(dst-d-1);

				if(++dst >= end)
				{
					break;
				}
			}
		}
		
		cnt++;
	}

	return 0;
}
